PROGRAM Labyworm;
USES CRT, DOS;

CONST Spanz : BYTE = 4; Slange : BYTE = 10; maxx = 63; maxy = 37;
      maxber = maxx*maxy;
      gefunden = 2;
      farbe : array[1..4] of byte = (1,2,3,4);

TYPE s = ARRAY [0..20] OF RECORD  x, y : BYTE; END;
     sc = ARRAY [0..maxx, 0..maxy] OF BYTE;
  punktfeld = ARRAY [0..maxber] OF RECORD
    x, y          : byte;
    vorgangerfeld : Word;
  END;
  ergebnisfeld = RECORD
                   x, y : BYTE;
                   p    : POINTER; { Zeiger auf nchstes Feld }
                 END;
  ergebnisfeldp = ^ergebnisfeld;
  np = ^nt;
  nt = record st: string; p: np; end;

VAR
  schl                      : ARRAY [1..4] OF s;
  dummyrich                 : ARRAY [1..4] OF BYTE;
  schlp                     : ARRAY [1..4 ] OF RECORD x, y, rich, c, ziel,st : BYTE;p: word;END;
  del                       : array [1..4] of boolean;
  gefressen                 : array [1..4,1..4] OF WORD;
  int1, int2, int3, verz,
  int4,x, y, wechsl,gende   : integer;
  f                         : file of sc;
  cha                       : CHAR;
  J_N, ende                 : BOOLEAN;
  str1, str2, str3          : STRING;
  screen, screen2, feld2,bel: sc;
  timer, wegb, kills        : LONGINT;
  erg, erg2                 : ergebnisfeldp;
  p1, p2                    : POINTER;
  punkte                    : ^punktfeld;
  dname                     : searchrec;
  namen, namen2             : np;

procedure delay(time: longint);
var  wo1, wo2, wo3, wo4    : WORD;
     intl,intl2,intmax     : longint;
begin
 if time = 0 then exit;
 gettime(wo1,wo2,wo3,wo4);
 intl := longint(wo4)+longint(wo3)*60+longint(wo2)*3600+longint(wo1)*360000;
 intmax := 0;
 repeat
   gettime(wo1,wo2,wo3,wo4);
   intmax := intmax +1;
   intl2 := longint(wo4)+longint(wo3)*60+longint(wo2)*3600+longint(wo1)*360000;
 until (abs(intl2 - intl) > time) OR (intmax > 640000);
end;


FUNCTION wegf (vx, vy, nx, ny : BYTE) : POINTER; {wegf ist Zeiger auf 1. Wegpunkt}
VAR berp, maxp, fertige, zielfeld, vorg,
    wieviel_felder                            : WORD;
    status                                    : BYTE;
    ergb, ergb2                               : ergebnisfeldp;

PROCEDURE erstelleneu (x_, y_ : BYTE);
BEGIN
  IF (x_ < 101) AND (x_ > 0) AND (y_ < 101) AND (y_ > 0) THEN BEGIN
     INC (maxp);
     WITH punkte^ [maxp] DO BEGIN
          vorgangerfeld:= berp;
          x := x_;
          y := y_;
          feld2 [x_, y_] := 1;
     END;
     IF (x_ = nx) AND (y_ = ny) THEN BEGIN status:= status or gefunden; zielfeld := berp; END;
  END;
END;

BEGIN
  inc(wegb);
  if (screen[vx,vy]<>0) OR (screen[nx,ny] <>0) then begin wegf:= nil;exit;end;
  feld2 := screen2;
  status:= 0;
  feld2 [vx, vy] := 1;
  berp:= 0;
  maxp := 0;
  WITH punkte^[0] DO BEGIN
    x := vx;
    y := vy;
    vorgangerfeld := 0;
  END;
  WHILE (berp <= maxp) AND (status <> gefunden) DO BEGIN
    WITH punkte^ [berp] DO BEGIN
      IF feld2 [x    , y - 1] = 0 THEN erstelleneu (x    , y - 1);
      IF feld2 [x - 1, y    ] = 0 THEN erstelleneu (x - 1, y    );
      IF feld2 [x + 1, y    ] = 0 THEN erstelleneu (x + 1, y    );
      IF feld2 [x    , y + 1] = 0 THEN erstelleneu (x    , y + 1);
    END;
    INC (berp);
  END;
  NEW (ergb);
  ergb^.p := NIL;
  ergb^.x := nx;
  ergb^.y := ny;
  if status <> gefunden then begin wegf:= ergb; exit; END;
     vorg:= punkte^[zielfeld].vorgangerfeld;
     WHILE vorg <> 0 DO BEGIN  {solange nicht auf Startfeld}
       ergb2 := ergb;
       NEW (ergb);          { ergb^.p zeigt auf alten Zeiger (nchsten Punkt}
       ergb^.p := ergb2;
       WITH punkte^[vorg] DO BEGIN
         ergb^.x := x;
         ergb^.y := y;
         vorg    := vorgangerfeld;
       END;
     END;
     wegf := ergb;
END;

procedure putpixel(x,y: word; c: byte);
begin
  mem[$a000:x+y*320]:= c;
end;


procedure fillfeld(x,y: word; c: byte);
var i,i2: integer;
begin
  bel[x,y]:= c;
  x:= x*5;y:= y*5;
  putpixel(x+2, y+0, c);
  putpixel(x+1, y+1, c);
  putpixel(x+2, y+1, c);
  putpixel(x+3, y+1, c);
  putpixel(x+0, y+2, c);
  putpixel(x+1, y+2, c);
  putpixel(x+2, y+2, c);
  putpixel(x+3, y+2, c);
  putpixel(x+4, y+2, c);
  putpixel(x+1, y+3, c);
  putpixel(x+2, y+3, c);
  putpixel(x+3, y+3, c);
  putpixel(x+2, y+4, c);
end;

PROCEDURE aktualsc;
var int1,int2,int3: integer;
BEGIN
  FILLCHAR (mem [$a000 : 000], 64000, 0);
  FOR int1 := 0 TO maxx DO
    FOR int2 := 0 TO maxy DO
      IF screen [int1, int2] <> 0 THEN BEGIN
        for int3:= 0 to 4 do
          for int4:= 0 to 4 do
            putpixel(int1*5+int3,int2*5+int4,screen[int1,int2]);
        if screen[int1,int2] >= 200 then fillfeld(int1,int2,0);
      END;
END;

PROCEDURE OUTTEXTXY(x,y: integer; ST: STRING; c: byte);
var  Table : array[0..256,0..7] of byte absolute $ffa6:$e;
     int1, int2, int3, d : integer;

BEGIN
if (y > 0) AND (y < 768) AND (x < 1024) then
  for int1:= 1 to length(st) do
    if (x+int1*9 < 1024) AND (x+int1*9 > -8) then
    for int2:= 0 to 7 do begin
      d:= table[ord(st[int1]),int2];
      for int3:= 0 to 7 do
        if d AND (128 shr int3) <> 0 then
          putpixel(x+(int1-1)*9+int3,y+int2,c);
    end;
END;
procedure computergegner(nr: byte);
var int1: integer; richv : byte;

procedure fernkampf(nr: byte);
begin
  with schlp[nr] do
  erg := wegf(x, y, schl[schlp[nr].ziel,(timer-10) MOD 20].x+random(2)-1,
                    schl[schlp[nr].ziel,(timer-10) MOD 20].y+random(2)-1);
  if erg <> nil then BEGIN
    if (erg^.x < schlp[nr].x) then schlp[nr].rich:= 4;
    if (erg^.x > schlp[nr].x) then schlp[nr].rich:= 2;
    if (erg^.y < schlp[nr].y) then schlp[nr].rich:= 1;
    if (erg^.y > schlp[nr].y) then schlp[nr].rich:= 3;
    WHILE erg^.p <> NIL DO BEGIN
      erg2 := erg;
      erg  := erg^.p;
      dispose(erg2);
    END;
    dispose(erg);
  END;
end;

begin
  richv:= schlp[nr].rich;
  int1:= 10000;
  for int2:= 1 to 4 do
    if (int2 <> nr) AND (schlp[int2].c <>0) and
      (abs(schlp[nr].x-schlp[int2].x)+abs(schlp[nr].y-schlp[int2].y) < int1) then begin
       schlp[nr].ziel := int2;
       int1 := abs(schlp[nr].x-schlp[int2].x)+abs(schlp[nr].y-schlp[int2].y);
    END;
  fernkampf(nr);
  IF (ABS(richv - schlp [nr] .rich) MOD 4 = 2) THEN
    inc(schlp[nr].rich);
  if schlp[nr].rich > 4 then dec(schlp[nr].rich,4);
end;

procedure setzeschlange(i: byte);
begin
   with schlp[i] do
   REPEAT
      x := random(maxx);
      y := random(maxy);
   UNTIL screen[x, y] = 0;
   fillchar(schl[i],sizeof(schl[i]),0);
end;

procedure levelladen;
begin
  namen:= namen^.p;
  if namen^.st = '' then namen:= namen^.p;
  assign(f,namen^.st);
  reset(f);
  read (f,screen);
  close(f);
  for int3:= 0 to maxx do for int2:= 0 to maxy do if screen[int3,int2] >=200 then
    screen2[int3,int2]:= 0 else screen2[int3,int2]:= screen[int3,int2];
  aktualsc;
  fillchar(bel,sizeof(bel),0);
  for int3:= 1 to spanz do begin
    setzeschlange(int3);
    STR (schlp[int3].p, str1);
    OUTTEXTXY (10+int3*40, 190, str1, farbe[int3]);
  END;
End;

BEGIN
  verz := 1;
  int1 := 0;
  if paramcount <> 0 then val(paramstr(1),verz,int1);
  if int1 <> 0 then verz := 1;
  kills:= 0;
  randomize;
  new(punkte);
  asm mov ax, $13; int $10; end;
  outtextxy(100,100,' LABYWORM II ',15);
  outtextxy(100,115,' v1.1  by Leo', 20);
  str(verz,str1);
  outtextxy(0,180,'Speed '+str1,15);
  outtextxy(0,190,' Numlock muss leuchten',15);
  new(namen);
  p1:= namen;
  findfirst('level???.DAT',$2f,dname);
  while doserror = 0 do begin
    namen^.st:= dname.name;
    namen2 := namen;
    new(namen);
    namen2^.p:= namen;
    findnext(dname);
  end;
  namen2^.p:= p1;
  namen:= p1;
  readkey;
  fillchar(mem[$a000:0],64000,0);
  outtextxy(10,50,'- M fuer Mensch,',15);
  outtextxy(10,60,'- 1..9 fuer Computer (Staerke)',15);
  outtextxy(10,70,'- Anderes fuer aus',15);
  for int1:= 1 to spanz do begin
    str (int1,str1);
    outtextxy(50,80+int1*10,str1+ '. Spieler:',15);
    cha:= upcase(readkey);
    outtextxy(150,80+int1*10,cha,15);
    schlp[int1].c:= 0;
    if cha = 'M' then schlp[int1].c:= 1;
    val(cha,schlp[int1].st,int2);
    schlp[int1].st := 10-schlp[int1].st;
    if int2 = 0 then schlp[int1].c:= 2;
  end;
  textcolor(15);
  for int2 := 0 to 16 do writeln;
  outtextxy(0,130,'Nach wievielen Kills Level wechseln?',15);
  readln(wechsl);
  writeln; writeln;
  if wechsl = 0 then wechsl := 32767;
  outtextxy(0,150,'Nach wievielen Kills Spiel beenden?',15);
  readln(gende);
  fillchar(mem[$a000:0],64000,0);
  wegb:= 0;
  fillchar(gefressen,sizeof(gefressen),0);
  for int1:= 1 to spanz do BEGIN schlp[int1].p:= 0; schlp[int1].ziel:= 0;end;
  for int1:= 200 to 255 do begin port[$3c8]:= int1;port[$3c9]:= 50;port[$3c9]:= 0;port[$3c9]:= 50;end;
  levelladen;
  REPEAT
    schlp [1] .y := maxy div 2; schlp [1] .x := 2;      schlp [1] .rich := 1;
    schlp [2] .y := maxy div 2; schlp [2] .x := maxx-2; schlp [2] .rich := 3;
    schlp [3] .y := 2; schlp [3] .x := maxx div 2; schlp [3] .rich := 2;
    schlp [4] .y := maxy- 2; schlp [4] .x := maxx div 2; schlp [4] .rich := 4;
    timer := 20;
    FOR int1 := 1 TO spanz DO
        FOR int2 := 0 TO 20 DO BEGIN
          schl [int1, int2] .x := schlp [int1] .x;
          schl [int1, int2] .y := schlp [int1] .y;
        END;
    ende := FALSE;
    REPEAT
    port[$3c8]:= 200;
    for int1:= 1 to 56 do
      if timer mod int1 = 0 then begin
        port[$3c9]:= 0;
        port[$3c9]:= 0;
        port[$3c9]:= 0;
      end else begin
        port[$3c9]:= 60;
        port[$3c9]:= 60;
        port[$3c9]:= 60;
      end;
      DELAY (verz);
      INC (timer);
      FOR int1 := 1 TO Spanz DO
        WITH schlp [int1] DO BEGIN
         schl [int1, timer MOD 20] .x := x;
         schl [int1, timer MOD 20] .y := y;
         CASE rich OF
           1 : DEC (y);
           2 : INC (x);
           3 : INC (y);
           4 : DEC (x);
         END;
         IF x < 1 THEN x := 1;
         IF x > maxx THEN x := maxx;
         IF y < 1 THEN y := 1;
         IF y > maxy THEN y := maxy;
         IF (screen[x,y] IN [1..199]) OR (((screen[x,y] > 199) AND (timer mod (screen[x,y]-199) <> 0))) then begin
           y := schl[int1, timer MOD 20].y;
           x := schl[int1, timer MOD 20].x;
         END;
      END;
      WHILE KEYPRESSED DO BEGIN
        FOR int1 := 1 TO 4 DO dummyrich [int1] := schlp [int1].rich;
        cha := UPCASE (READKEY);
        CASE cha OF
           #0 : BEGIN
                  cha := READKEY;
                  CASE cha OF
                    #72 :  schlp [1] .rich := 1;
                    #75 :  schlp [1] .rich := 4;
                    #77 :  schlp [1] .rich := 2;
                    #80 :  schlp [1] .rich := 3;
                  END;
                END;
           'A' : schlp [2] .rich := 4;
           'S' : schlp [2] .rich := 3;
           'D' : schlp [2] .rich := 2;
           'W' : schlp [2] .rich := 1;
           'J' : schlp [3] .rich := 4;
           'K' : schlp [3] .rich := 3;
           'L' : schlp [3] .rich := 2;
           'I' : schlp [3] .rich := 1;
           '4' : schlp [4] .rich := 4;
           '2' : schlp [4] .rich := 3;
           '6' : schlp [4] .rich := 2;
           '8' : schlp [4] .rich := 1;
        END;
        FOR int1 := 1 TO 4 DO
          IF (schlp[int1].c >= 2) OR (ABS(dummyrich [int1] - schlp [int1] .rich) MOD 4 = 2) THEN
            schlp [int1] .rich := dummyrich [int1];
      END;
      for int1 := 1 to spanz do del[int1]:= false;
      for int1:= 1 to 4 do
        if (schlp[int1].c >=2) AND (random(schlp[int1].st*2) = 0) then computergegner(int1);
      FOR int1 := 1 TO Spanz DO if schlp[int1].c <> 0 then BEGIN
        if (bel[schlp[int1].x,schlp[int1].y]<>0) AND (bel[schlp[int1].x,schlp[int1].y]<>farbe[int1]) {AND
           (not ((x=schl[int1,(timer-2) mod 20].x) AND (y = schl[int1,(timer-2) mod 20].y)))} then
          for int2:= 1 to spanz do
            if (int1<>int2) AND (bel[schlp[int1].x,schlp[int1].y]= farbe[int2]) then begin
              del[int2]:= true;
              inc(gefressen[int1,int2]);
              STR (schlp[int1].p, str1);
              outtextxy(10+int1*40, 190, str1, 0);
              inc(schlp[int1].p);
              STR (schlp[int1].p, str1);
              OUTTEXTXY (10+int1*40, 190, str1, farbe[int1]);
            END;
      END;
      FOR int1 := 1 TO Spanz DO if schlp[int1].c <> 0 then BEGIN
        fillfeld(schl[int1, (timer - Slange) MOD 20].x,schl[int1, (timer - Slange) MOD 20].y,0);
        for int2:= 1 to slange-1 do fillfeld(schl[int1,(timer-int2)mod 20].x,schl[int1,(timer-int2)mod 20].y,farbe[int1]);
        fillfeld(schlp[int1].x, schlp[int1].y, farbe[int1]);
        putpixel(schlp[int1].x*5+2,schlp[int1].y*5+2,15);
      END;
      for int1:= 1 to spanz do
        if del[int1] then with schlp[int1] do begin
          inc(kills);
          if kills mod wechsl = 0 then
            levelladen;
          fillfeld(x, y,0);
          for int2:= 0 to 20 do
            fillfeld(schl[int1,int2].x,schl[int1,int2].y,0);
          setzeschlange(int1);
        end;
    UNTIL (port [$60] = 1) OR ende or (kills >=gende);
  UNTIL (port [$60] = 1) or (kills >=gende);
  fillchar(mem[$a000:000],64000,0);
  outtextxy(70,20,'DIE FAKTEN',15);
  outtextxy(1,40,'             1    2    3    4   GES',15);
  for int1:= 1 to spanz do begin
    str1:= '-';
    if schlp[int1].c = 2 then begin
      str(10-schlp[int1].st,str1);
      str1:= 'C'+str1;
    END;
    if schlp[int1].c= 1 then str1:= 'M';
    str(int1,str2);
    outtextxy(1,40+10*int1,'WURM '+str2+' : '+str1,farbe[int1]);
    for int2:= 1 to spanz do begin
      str(gefressen[int1,int2],str1);
      if int1= int2 then str1:= '- ';
      outtextxy(70+int2*46,40+10*int1,str1,farbe[int1]);
    end;
    str(schlp[int1].p,str1);
    outtextxy(290,40+10*int1,str1,farbe[int1]);
  END;
  while keypressed do readkey;
  str(kills,str1);
  outtextxy(1,100,'Es wurden '+str1+' Schlangen gefressen.',15);
  str(timer*4,str1);
  outtextxy(0,110,'Der Boden wurde '+str1+'mal zertrampelt',15);
  str(wegb,str1);
  outtextxy(0,130,'Der Weg wurde '+str1+' Mal berechnet.',15);
  str(verz,str1);
  outtextxy(0,150,'Und ich durfte pro Spielzug '+str1,15);
  outtextxy(0,160,'Millisekunden Pause machen!',15);
  while keypressed do readkey;
  outtextxy(1,180,'TSCHAU',14);
  outtextxy(0,190,'Ende mit Esc',25);
  repeat cha:= readkey; until cha = #27;
  asm mov ax, $3; int $10; end;
  dispose(punkte);
  dispose(namen); { passt scho }
END.